// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from vda5050_msgs:msg/AGVAction.idl
// generated code does not contain a copyright notice

#ifndef VDA5050_MSGS__MSG__DETAIL__AGV_ACTION__TRAITS_HPP_
#define VDA5050_MSGS__MSG__DETAIL__AGV_ACTION__TRAITS_HPP_

#include "vda5050_msgs/msg/detail/agv_action__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'action_parameters'
#include "vda5050_msgs/msg/detail/action_parameter_definition__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const vda5050_msgs::msg::AGVAction & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: action_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "action_type: ";
    value_to_yaml(msg.action_type, out);
    out << "\n";
  }

  // member: action_description
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "action_description: ";
    value_to_yaml(msg.action_description, out);
    out << "\n";
  }

  // member: action_scopes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.action_scopes.size() == 0) {
      out << "action_scopes: []\n";
    } else {
      out << "action_scopes:\n";
      for (auto item : msg.action_scopes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: action_parameters
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.action_parameters.size() == 0) {
      out << "action_parameters: []\n";
    } else {
      out << "action_parameters:\n";
      for (auto item : msg.action_parameters) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: result_description
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result_description: ";
    value_to_yaml(msg.result_description, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const vda5050_msgs::msg::AGVAction & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<vda5050_msgs::msg::AGVAction>()
{
  return "vda5050_msgs::msg::AGVAction";
}

template<>
inline const char * name<vda5050_msgs::msg::AGVAction>()
{
  return "vda5050_msgs/msg/AGVAction";
}

template<>
struct has_fixed_size<vda5050_msgs::msg::AGVAction>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<vda5050_msgs::msg::AGVAction>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<vda5050_msgs::msg::AGVAction>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // VDA5050_MSGS__MSG__DETAIL__AGV_ACTION__TRAITS_HPP_
