// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from vda5050_msgs:msg/AGVGeometry.idl
// generated code does not contain a copyright notice

#ifndef VDA5050_MSGS__MSG__DETAIL__AGV_GEOMETRY__TRAITS_HPP_
#define VDA5050_MSGS__MSG__DETAIL__AGV_GEOMETRY__TRAITS_HPP_

#include "vda5050_msgs/msg/detail/agv_geometry__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'wheel_definitions'
#include "vda5050_msgs/msg/detail/wheel_definition__traits.hpp"
// Member 'envelopes2d'
#include "vda5050_msgs/msg/detail/envelope2_d__traits.hpp"
// Member 'envelopes3d'
#include "vda5050_msgs/msg/detail/envelope3_d__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const vda5050_msgs::msg::AGVGeometry & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: wheel_definitions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.wheel_definitions.size() == 0) {
      out << "wheel_definitions: []\n";
    } else {
      out << "wheel_definitions:\n";
      for (auto item : msg.wheel_definitions) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: envelopes2d
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.envelopes2d.size() == 0) {
      out << "envelopes2d: []\n";
    } else {
      out << "envelopes2d:\n";
      for (auto item : msg.envelopes2d) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: envelopes3d
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.envelopes3d.size() == 0) {
      out << "envelopes3d: []\n";
    } else {
      out << "envelopes3d:\n";
      for (auto item : msg.envelopes3d) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const vda5050_msgs::msg::AGVGeometry & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<vda5050_msgs::msg::AGVGeometry>()
{
  return "vda5050_msgs::msg::AGVGeometry";
}

template<>
inline const char * name<vda5050_msgs::msg::AGVGeometry>()
{
  return "vda5050_msgs/msg/AGVGeometry";
}

template<>
struct has_fixed_size<vda5050_msgs::msg::AGVGeometry>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<vda5050_msgs::msg::AGVGeometry>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<vda5050_msgs::msg::AGVGeometry>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // VDA5050_MSGS__MSG__DETAIL__AGV_GEOMETRY__TRAITS_HPP_
