// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from vda5050_msgs:msg/Edge.idl
// generated code does not contain a copyright notice

#ifndef VDA5050_MSGS__MSG__DETAIL__EDGE__STRUCT_H_
#define VDA5050_MSGS__MSG__DETAIL__EDGE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'edge_id'
// Member 'edge_description'
// Member 'start_node_id'
// Member 'end_node_id'
// Member 'direction'
#include "rosidl_runtime_c/string.h"
// Member 'trajectory'
#include "vda5050_msgs/msg/detail/trajectory__struct.h"
// Member 'actions'
#include "vda5050_msgs/msg/detail/action__struct.h"

// Struct defined in msg/Edge in the package vda5050_msgs.
typedef struct vda5050_msgs__msg__Edge
{
  rosidl_runtime_c__String edge_id;
  uint32_t sequence_id;
  rosidl_runtime_c__String edge_description;
  bool released;
  rosidl_runtime_c__String start_node_id;
  rosidl_runtime_c__String end_node_id;
  double max_speed;
  double max_height;
  double min_height;
  double orientation;
  rosidl_runtime_c__String direction;
  bool rotation_allowed;
  double max_rotation_speed;
  vda5050_msgs__msg__Trajectory trajectory;
  double length;
  vda5050_msgs__msg__Action__Sequence actions;
} vda5050_msgs__msg__Edge;

// Struct for a sequence of vda5050_msgs__msg__Edge.
typedef struct vda5050_msgs__msg__Edge__Sequence
{
  vda5050_msgs__msg__Edge * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} vda5050_msgs__msg__Edge__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // VDA5050_MSGS__MSG__DETAIL__EDGE__STRUCT_H_
