// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from vda5050_msgs:msg/OrderState.idl
// generated code does not contain a copyright notice

#ifndef VDA5050_MSGS__MSG__DETAIL__ORDER_STATE__STRUCT_H_
#define VDA5050_MSGS__MSG__DETAIL__ORDER_STATE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'AUTOMATIC'.
static const char * const vda5050_msgs__msg__OrderState__AUTOMATIC = "AUTOMATIC";

/// Constant 'SEMIAUTOMATIC'.
static const char * const vda5050_msgs__msg__OrderState__SEMIAUTOMATIC = "SEMIAUTOMATIC";

/// Constant 'MANUAL'.
static const char * const vda5050_msgs__msg__OrderState__MANUAL = "MANUAL";

/// Constant 'SERVICE'.
static const char * const vda5050_msgs__msg__OrderState__SERVICE = "SERVICE";

/// Constant 'TEACHIN'.
static const char * const vda5050_msgs__msg__OrderState__TEACHIN = "TEACHIN";

// Include directives for member types
// Member 'timestamp'
// Member 'version'
// Member 'manufacturer'
// Member 'serial_number'
// Member 'order_id'
// Member 'zone_set_id'
// Member 'last_node_id'
// Member 'operating_mode'
#include "rosidl_runtime_c/string.h"
// Member 'node_states'
#include "vda5050_msgs/msg/detail/node_state__struct.h"
// Member 'edge_states'
#include "vda5050_msgs/msg/detail/edge_state__struct.h"
// Member 'agv_position'
#include "vda5050_msgs/msg/detail/agv_position__struct.h"
// Member 'velocity'
#include "vda5050_msgs/msg/detail/velocity__struct.h"
// Member 'loads'
#include "vda5050_msgs/msg/detail/load__struct.h"
// Member 'action_states'
#include "vda5050_msgs/msg/detail/current_action__struct.h"
// Member 'battery_state'
#include "vda5050_msgs/msg/detail/battery_state__struct.h"
// Member 'errors'
#include "vda5050_msgs/msg/detail/error__struct.h"
// Member 'informations'
#include "vda5050_msgs/msg/detail/info__struct.h"
// Member 'safety_state'
#include "vda5050_msgs/msg/detail/safety_state__struct.h"

// Struct defined in msg/OrderState in the package vda5050_msgs.
typedef struct vda5050_msgs__msg__OrderState
{
  uint32_t header_id;
  rosidl_runtime_c__String timestamp;
  rosidl_runtime_c__String version;
  rosidl_runtime_c__String manufacturer;
  rosidl_runtime_c__String serial_number;
  rosidl_runtime_c__String order_id;
  uint32_t order_update_id;
  rosidl_runtime_c__String zone_set_id;
  rosidl_runtime_c__String last_node_id;
  uint32_t last_node_sequence_id;
  vda5050_msgs__msg__NodeState__Sequence node_states;
  vda5050_msgs__msg__EdgeState__Sequence edge_states;
  vda5050_msgs__msg__AGVPosition agv_position;
  vda5050_msgs__msg__Velocity velocity;
  vda5050_msgs__msg__Load__Sequence loads;
  bool driving;
  bool paused;
  bool new_base_requested;
  double distance_since_last_node;
  vda5050_msgs__msg__CurrentAction__Sequence action_states;
  vda5050_msgs__msg__BatteryState battery_state;
  rosidl_runtime_c__String operating_mode;
  vda5050_msgs__msg__Error__Sequence errors;
  vda5050_msgs__msg__Info__Sequence informations;
  vda5050_msgs__msg__SafetyState safety_state;
} vda5050_msgs__msg__OrderState;

// Struct for a sequence of vda5050_msgs__msg__OrderState.
typedef struct vda5050_msgs__msg__OrderState__Sequence
{
  vda5050_msgs__msg__OrderState * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} vda5050_msgs__msg__OrderState__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // VDA5050_MSGS__MSG__DETAIL__ORDER_STATE__STRUCT_H_
