// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from vda5050_msgs:msg/OrderState.idl
// generated code does not contain a copyright notice

#ifndef VDA5050_MSGS__MSG__DETAIL__ORDER_STATE__TRAITS_HPP_
#define VDA5050_MSGS__MSG__DETAIL__ORDER_STATE__TRAITS_HPP_

#include "vda5050_msgs/msg/detail/order_state__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'node_states'
#include "vda5050_msgs/msg/detail/node_state__traits.hpp"
// Member 'edge_states'
#include "vda5050_msgs/msg/detail/edge_state__traits.hpp"
// Member 'agv_position'
#include "vda5050_msgs/msg/detail/agv_position__traits.hpp"
// Member 'velocity'
#include "vda5050_msgs/msg/detail/velocity__traits.hpp"
// Member 'loads'
#include "vda5050_msgs/msg/detail/load__traits.hpp"
// Member 'action_states'
#include "vda5050_msgs/msg/detail/current_action__traits.hpp"
// Member 'battery_state'
#include "vda5050_msgs/msg/detail/battery_state__traits.hpp"
// Member 'errors'
#include "vda5050_msgs/msg/detail/error__traits.hpp"
// Member 'informations'
#include "vda5050_msgs/msg/detail/info__traits.hpp"
// Member 'safety_state'
#include "vda5050_msgs/msg/detail/safety_state__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const vda5050_msgs::msg::OrderState & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header_id: ";
    value_to_yaml(msg.header_id, out);
    out << "\n";
  }

  // member: timestamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timestamp: ";
    value_to_yaml(msg.timestamp, out);
    out << "\n";
  }

  // member: version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "version: ";
    value_to_yaml(msg.version, out);
    out << "\n";
  }

  // member: manufacturer
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "manufacturer: ";
    value_to_yaml(msg.manufacturer, out);
    out << "\n";
  }

  // member: serial_number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "serial_number: ";
    value_to_yaml(msg.serial_number, out);
    out << "\n";
  }

  // member: order_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "order_id: ";
    value_to_yaml(msg.order_id, out);
    out << "\n";
  }

  // member: order_update_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "order_update_id: ";
    value_to_yaml(msg.order_update_id, out);
    out << "\n";
  }

  // member: zone_set_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "zone_set_id: ";
    value_to_yaml(msg.zone_set_id, out);
    out << "\n";
  }

  // member: last_node_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "last_node_id: ";
    value_to_yaml(msg.last_node_id, out);
    out << "\n";
  }

  // member: last_node_sequence_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "last_node_sequence_id: ";
    value_to_yaml(msg.last_node_sequence_id, out);
    out << "\n";
  }

  // member: node_states
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.node_states.size() == 0) {
      out << "node_states: []\n";
    } else {
      out << "node_states:\n";
      for (auto item : msg.node_states) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: edge_states
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.edge_states.size() == 0) {
      out << "edge_states: []\n";
    } else {
      out << "edge_states:\n";
      for (auto item : msg.edge_states) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: agv_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "agv_position:\n";
    to_yaml(msg.agv_position, out, indentation + 2);
  }

  // member: velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "velocity:\n";
    to_yaml(msg.velocity, out, indentation + 2);
  }

  // member: loads
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.loads.size() == 0) {
      out << "loads: []\n";
    } else {
      out << "loads:\n";
      for (auto item : msg.loads) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: driving
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "driving: ";
    value_to_yaml(msg.driving, out);
    out << "\n";
  }

  // member: paused
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "paused: ";
    value_to_yaml(msg.paused, out);
    out << "\n";
  }

  // member: new_base_requested
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "new_base_requested: ";
    value_to_yaml(msg.new_base_requested, out);
    out << "\n";
  }

  // member: distance_since_last_node
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance_since_last_node: ";
    value_to_yaml(msg.distance_since_last_node, out);
    out << "\n";
  }

  // member: action_states
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.action_states.size() == 0) {
      out << "action_states: []\n";
    } else {
      out << "action_states:\n";
      for (auto item : msg.action_states) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: battery_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "battery_state:\n";
    to_yaml(msg.battery_state, out, indentation + 2);
  }

  // member: operating_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "operating_mode: ";
    value_to_yaml(msg.operating_mode, out);
    out << "\n";
  }

  // member: errors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.errors.size() == 0) {
      out << "errors: []\n";
    } else {
      out << "errors:\n";
      for (auto item : msg.errors) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: informations
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.informations.size() == 0) {
      out << "informations: []\n";
    } else {
      out << "informations:\n";
      for (auto item : msg.informations) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: safety_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "safety_state:\n";
    to_yaml(msg.safety_state, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const vda5050_msgs::msg::OrderState & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<vda5050_msgs::msg::OrderState>()
{
  return "vda5050_msgs::msg::OrderState";
}

template<>
inline const char * name<vda5050_msgs::msg::OrderState>()
{
  return "vda5050_msgs/msg/OrderState";
}

template<>
struct has_fixed_size<vda5050_msgs::msg::OrderState>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<vda5050_msgs::msg::OrderState>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<vda5050_msgs::msg::OrderState>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // VDA5050_MSGS__MSG__DETAIL__ORDER_STATE__TRAITS_HPP_
