// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vda5050_msgs:msg/Velocity.idl
// generated code does not contain a copyright notice
#include "vda5050_msgs/msg/detail/velocity__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


bool
vda5050_msgs__msg__Velocity__init(vda5050_msgs__msg__Velocity * msg)
{
  if (!msg) {
    return false;
  }
  // vx
  // vy
  // omega
  return true;
}

void
vda5050_msgs__msg__Velocity__fini(vda5050_msgs__msg__Velocity * msg)
{
  if (!msg) {
    return;
  }
  // vx
  // vy
  // omega
}

bool
vda5050_msgs__msg__Velocity__are_equal(const vda5050_msgs__msg__Velocity * lhs, const vda5050_msgs__msg__Velocity * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // vx
  if (lhs->vx != rhs->vx) {
    return false;
  }
  // vy
  if (lhs->vy != rhs->vy) {
    return false;
  }
  // omega
  if (lhs->omega != rhs->omega) {
    return false;
  }
  return true;
}

bool
vda5050_msgs__msg__Velocity__copy(
  const vda5050_msgs__msg__Velocity * input,
  vda5050_msgs__msg__Velocity * output)
{
  if (!input || !output) {
    return false;
  }
  // vx
  output->vx = input->vx;
  // vy
  output->vy = input->vy;
  // omega
  output->omega = input->omega;
  return true;
}

vda5050_msgs__msg__Velocity *
vda5050_msgs__msg__Velocity__create()
{
  vda5050_msgs__msg__Velocity * msg = (vda5050_msgs__msg__Velocity *)malloc(sizeof(vda5050_msgs__msg__Velocity));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vda5050_msgs__msg__Velocity));
  bool success = vda5050_msgs__msg__Velocity__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
vda5050_msgs__msg__Velocity__destroy(vda5050_msgs__msg__Velocity * msg)
{
  if (msg) {
    vda5050_msgs__msg__Velocity__fini(msg);
  }
  free(msg);
}


bool
vda5050_msgs__msg__Velocity__Sequence__init(vda5050_msgs__msg__Velocity__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  vda5050_msgs__msg__Velocity * data = NULL;
  if (size) {
    data = (vda5050_msgs__msg__Velocity *)calloc(size, sizeof(vda5050_msgs__msg__Velocity));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vda5050_msgs__msg__Velocity__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vda5050_msgs__msg__Velocity__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vda5050_msgs__msg__Velocity__Sequence__fini(vda5050_msgs__msg__Velocity__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vda5050_msgs__msg__Velocity__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vda5050_msgs__msg__Velocity__Sequence *
vda5050_msgs__msg__Velocity__Sequence__create(size_t size)
{
  vda5050_msgs__msg__Velocity__Sequence * array = (vda5050_msgs__msg__Velocity__Sequence *)malloc(sizeof(vda5050_msgs__msg__Velocity__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = vda5050_msgs__msg__Velocity__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
vda5050_msgs__msg__Velocity__Sequence__destroy(vda5050_msgs__msg__Velocity__Sequence * array)
{
  if (array) {
    vda5050_msgs__msg__Velocity__Sequence__fini(array);
  }
  free(array);
}

bool
vda5050_msgs__msg__Velocity__Sequence__are_equal(const vda5050_msgs__msg__Velocity__Sequence * lhs, const vda5050_msgs__msg__Velocity__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!vda5050_msgs__msg__Velocity__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
vda5050_msgs__msg__Velocity__Sequence__copy(
  const vda5050_msgs__msg__Velocity__Sequence * input,
  vda5050_msgs__msg__Velocity__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(vda5050_msgs__msg__Velocity);
    vda5050_msgs__msg__Velocity * data =
      (vda5050_msgs__msg__Velocity *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!vda5050_msgs__msg__Velocity__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          vda5050_msgs__msg__Velocity__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!vda5050_msgs__msg__Velocity__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
