// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from vda5050_msgs:msg/Edge.idl
// generated code does not contain a copyright notice

#ifndef VDA5050_MSGS__MSG__DETAIL__EDGE__TRAITS_HPP_
#define VDA5050_MSGS__MSG__DETAIL__EDGE__TRAITS_HPP_

#include "vda5050_msgs/msg/detail/edge__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'trajectory'
#include "vda5050_msgs/msg/detail/trajectory__traits.hpp"
// Member 'actions'
#include "vda5050_msgs/msg/detail/action__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const vda5050_msgs::msg::Edge & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: edge_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "edge_id: ";
    value_to_yaml(msg.edge_id, out);
    out << "\n";
  }

  // member: sequence_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sequence_id: ";
    value_to_yaml(msg.sequence_id, out);
    out << "\n";
  }

  // member: edge_description
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "edge_description: ";
    value_to_yaml(msg.edge_description, out);
    out << "\n";
  }

  // member: released
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "released: ";
    value_to_yaml(msg.released, out);
    out << "\n";
  }

  // member: start_node_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start_node_id: ";
    value_to_yaml(msg.start_node_id, out);
    out << "\n";
  }

  // member: end_node_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "end_node_id: ";
    value_to_yaml(msg.end_node_id, out);
    out << "\n";
  }

  // member: max_speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_speed: ";
    value_to_yaml(msg.max_speed, out);
    out << "\n";
  }

  // member: max_height
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_height: ";
    value_to_yaml(msg.max_height, out);
    out << "\n";
  }

  // member: min_height
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_height: ";
    value_to_yaml(msg.min_height, out);
    out << "\n";
  }

  // member: orientation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "orientation: ";
    value_to_yaml(msg.orientation, out);
    out << "\n";
  }

  // member: direction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "direction: ";
    value_to_yaml(msg.direction, out);
    out << "\n";
  }

  // member: rotation_allowed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rotation_allowed: ";
    value_to_yaml(msg.rotation_allowed, out);
    out << "\n";
  }

  // member: max_rotation_speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_rotation_speed: ";
    value_to_yaml(msg.max_rotation_speed, out);
    out << "\n";
  }

  // member: trajectory
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "trajectory:\n";
    to_yaml(msg.trajectory, out, indentation + 2);
  }

  // member: length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "length: ";
    value_to_yaml(msg.length, out);
    out << "\n";
  }

  // member: actions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.actions.size() == 0) {
      out << "actions: []\n";
    } else {
      out << "actions:\n";
      for (auto item : msg.actions) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const vda5050_msgs::msg::Edge & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<vda5050_msgs::msg::Edge>()
{
  return "vda5050_msgs::msg::Edge";
}

template<>
inline const char * name<vda5050_msgs::msg::Edge>()
{
  return "vda5050_msgs/msg/Edge";
}

template<>
struct has_fixed_size<vda5050_msgs::msg::Edge>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<vda5050_msgs::msg::Edge>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<vda5050_msgs::msg::Edge>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // VDA5050_MSGS__MSG__DETAIL__EDGE__TRAITS_HPP_
