// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from vda5050_msgs:msg/TypeSpecification.idl
// generated code does not contain a copyright notice

#ifndef VDA5050_MSGS__MSG__DETAIL__TYPE_SPECIFICATION__TRAITS_HPP_
#define VDA5050_MSGS__MSG__DETAIL__TYPE_SPECIFICATION__TRAITS_HPP_

#include "vda5050_msgs/msg/detail/type_specification__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const vda5050_msgs::msg::TypeSpecification & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: series_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "series_name: ";
    value_to_yaml(msg.series_name, out);
    out << "\n";
  }

  // member: series_description
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "series_description: ";
    value_to_yaml(msg.series_description, out);
    out << "\n";
  }

  // member: agv_kinematic
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "agv_kinematic: ";
    value_to_yaml(msg.agv_kinematic, out);
    out << "\n";
  }

  // member: agv_class
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "agv_class: ";
    value_to_yaml(msg.agv_class, out);
    out << "\n";
  }

  // member: max_load_mass
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_load_mass: ";
    value_to_yaml(msg.max_load_mass, out);
    out << "\n";
  }

  // member: localization_types
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.localization_types.size() == 0) {
      out << "localization_types: []\n";
    } else {
      out << "localization_types:\n";
      for (auto item : msg.localization_types) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: navigation_types
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.navigation_types.size() == 0) {
      out << "navigation_types: []\n";
    } else {
      out << "navigation_types:\n";
      for (auto item : msg.navigation_types) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const vda5050_msgs::msg::TypeSpecification & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<vda5050_msgs::msg::TypeSpecification>()
{
  return "vda5050_msgs::msg::TypeSpecification";
}

template<>
inline const char * name<vda5050_msgs::msg::TypeSpecification>()
{
  return "vda5050_msgs/msg/TypeSpecification";
}

template<>
struct has_fixed_size<vda5050_msgs::msg::TypeSpecification>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<vda5050_msgs::msg::TypeSpecification>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<vda5050_msgs::msg::TypeSpecification>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // VDA5050_MSGS__MSG__DETAIL__TYPE_SPECIFICATION__TRAITS_HPP_
